// Copyright (c) 2002 Rob Kaper <cap@capsi.com>
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License version 2.1 as published by the Free Software Foundation.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this library; see the file COPYING.LIB.  If not, write to
// the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
// Boston, MA 02111-1307, USA.

#ifndef LIBCAPSI_NETWORK_LISTENER_H
#define LIBCAPSI_NETWORK_LISTENER_H

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/time.h>
//#include <sys/socket.h>
#include <sys/types.h>
#include <unistd.h>
//#include <netinet/in.h>
#include <netdb.h>
#include <fcntl.h>

#include "socket.h"

#define	LISTENQ	1024

class ListenPort
{
	public:
		ListenPort(std::string host, int port);
		virtual ~ListenPort();
		int unblock();

        std::string ipAddr() { return m_ipAddr; }
        std::string fqdn() { return m_fqdn; }
		int port() { return m_port; }

		int fd;
		ListenPort *next;

	private:
		int tcpBind();
		int tcpListen();

        std::string m_ipAddr, m_fqdn;
		int m_port;
};

class Listener
{
	public:
		Listener();
		virtual ~Listener();
		void do_select();

		void setSocket(int); // public for softbooting
		int my_fd; // public for softbooting
		
	private:
		void set_timeval();

		int make_selectlist(Socket *);
		void tcpRead();
		void newSocket(int); // maybe remove int and move to LP?

		struct timeval my_tv;
		int my_listenfd, my_retval;
		unsigned int my_highest;
		Socket *my_newsock;
//		fd_set my_rfds;
};

extern void socketHandler(Socket *, std::string data);
extern fd_set listener_rfds;

// extern Listener *lis;

#endif // LIBCAPSI_NETWORK_LISTENER_H
